Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Static Public Member Functions | List of all members
Botan::Device_EntropySource Class Referencefinal

`#include <dev_random.h>`

Inheritance diagram for Botan::Device_EntropySource:

## Public Member Functions
| Device_EntropySource (const std::vector< std::string > &fsnames)
std::string | name () const override
size_t | poll (RandomNumberGenerator &rng) override
| ~Device_EntropySource ()

## Static Public Member Functions
static std::unique_ptr< Entropy_Source > | create (const std::string &type)

## Detailed Description

Entropy source reading from kernel devices like /dev/random

Definition at line 20 of file dev_random.h.

## Constructor & Destructor Documentation

## ◆ Device_EntropySource()

Botan::Device_EntropySource::Device_EntropySource | ( | const std::vector< std::string > & | fsnames | ) |
| explicit

Device_EntropySource constructor Open a file descriptor to each (available) device in fsnames

Definition at line 24 of file dev_random.cpp.

25 {
26#ifndef O_NONBLOCK
27 #define O_NONBLOCK 0
28#endif
29
30#ifndef O_NOCTTY
31 #define O_NOCTTY 0
32#endif
33
34 const int flags = O_RDONLY | O_NONBLOCK | O_NOCTTY;
35
36 m_max_fd = 0;
37
38 for(auto fsname : fsnames)
39 {
40 int fd = ::open(fsname.c_str(), flags);
41
42 if(fd < 0)
43 {
44 /*
45 ENOENT or EACCES is normal as some of the named devices may not exist
46 on this system. But any other errno value probably indicates
47 either a bug in the application or file descriptor exhaustion.
48 */
49 if(errno != ENOENT && errno != EACCES)
50 throw System_Error("Opening OS RNG device failed", errno);
51 }
52 else
53 {
54 if(fd > FD_SETSIZE)
55 {
56 ::close(fd);
57 throw Invalid_State("Open of OS RNG succeeded but returned fd is too large for fd_set");
58 }
59
60 m_dev_fds.push_back(fd);
61 m_max_fd = std::max(m_max_fd, fd);
62 }
63 }
64 }
O_NOCTTY
#define O_NOCTTY
O_NONBLOCK
#define O_NONBLOCK
Botan::PKCS11::flags
Flags flags(Flag flags)
Definition: p11.h:860

References Botan::PKCS11::flags(), O_NOCTTY, and O_NONBLOCK.

## ◆ ~Device_EntropySource()

Botan::Device_EntropySource::~Device_EntropySource | ( |  | ) |

Device_EntropySource destructor: close all open devices

Definition at line 69 of file dev_random.cpp.

70 {
71 for(int fd : m_dev_fds)
72 {
73 // ignoring return value here, can't throw in destructor anyway
74 ::close(fd);
75 }
76 }

## Member Function Documentation

## ◆ create()

std::unique_ptr< Entropy_Source > Botan::Entropy_Source::create | ( | const std::string & | type | ) |
| static inherited

Return a new entropy source of a particular type, or null Each entropy source may require substantial resources (eg, a file handle or socket instance), so try to share them among multiple RNGs, or just use the preconfigured global list accessed by Entropy_Sources::global_sources()

Definition at line 107 of file entropy_srcs.cpp.

108 {
109#if defined(BOTAN_HAS_SYSTEM_RNG)
110 if(name == "system_rng" || name == "win32_cryptoapi")
111 {
112 return std::unique_ptr<Entropy_Source>(new System_RNG_EntropySource);
113 }
114#endif
115
116#if defined(BOTAN_HAS_PROCESSOR_RNG)
117 if(name == "hwrng" || name == "rdrand" || name == "p9_darn")
118 {
119 if(Processor_RNG::available())
120 {
121 return std::unique_ptr<Entropy_Source>(new Processor_RNG_EntropySource);
122 }
123 }
124#endif
125
126#if defined(BOTAN_HAS_ENTROPY_SRC_RDSEED)
127 if(name == "rdseed")
128 {
129 return std::unique_ptr<Entropy_Source>(new Intel_Rdseed);
130 }
131#endif
132
133#if defined(BOTAN_HAS_ENTROPY_SRC_GETENTROPY)
134 if(name == "getentropy")
135 {
136 return std::unique_ptr<Entropy_Source>(new Getentropy);
137 }
138#endif
139
140#if defined(BOTAN_HAS_ENTROPY_SRC_DEV_RANDOM)
141 if(name == "dev_random")
142 {
143 return std::unique_ptr<Entropy_Source>(new Device_EntropySource(BOTAN_SYSTEM_RNG_POLL_DEVICES));
144 }
145#endif
146
147#if defined(BOTAN_HAS_ENTROPY_SRC_PROC_WALKER)
148 if(name == "proc_walk" && OS::running_in_privileged_state() == false)
149 {
150 const std::string root_dir = BOTAN_ENTROPY_PROC_FS_PATH;
151 if(!root_dir.empty())
152 return std::unique_ptr<Entropy_Source>(new ProcWalking_EntropySource(root_dir));
153 }
154#endif
155
156#if defined(BOTAN_HAS_ENTROPY_SRC_WIN32)
157 if(name == "system_stats")
158 {
159 return std::unique_ptr<Entropy_Source>(new Win32_EntropySource);
160 }
161#endif
162
163 BOTAN_UNUSED(name);
164 return std::unique_ptr<Entropy_Source>();
165 }
BOTAN_UNUSED
#define BOTAN_UNUSED(...)
Definition: assert.h:142
Botan::Entropy_Source::name
virtual std::string name() const =0
Botan::Processor_RNG::available
static bool available()
Definition: processor_rng.cpp:100
Botan::OS::running_in_privileged_state
bool running_in_privileged_state()
Definition: os_utils.cpp:143

References Botan::Processor_RNG::available(), BOTAN_UNUSED, Botan::Entropy_Source::name(), and Botan::OS::running_in_privileged_state().

Referenced by Botan::Entropy_Sources::Entropy_Sources().

## ◆ name()

std::string Botan::Device_EntropySource::name | ( |  | ) | const
| inline override virtual

Returns
  name identifying this entropy source

Implements Botan::Entropy_Source.

Definition at line 23 of file dev_random.h.

23{ return "dev_random"; }

## ◆ poll()

size_t Botan::Device_EntropySource::poll | ( | RandomNumberGenerator & | rng | ) |
| override virtual

Gather entropy from a RNG device

Implements Botan::Entropy_Source.

Definition at line 81 of file dev_random.cpp.

82 {
83 size_t bits = 0;
84
85 if(m_dev_fds.size() > 0)
86 {
87 fd_set read_set;
88 FD_ZERO(&read_set);
89
90 for(int dev_fd : m_dev_fds)
91 {
92 FD_SET(dev_fd, &read_set);
93 }
94
95 secure_vector<uint8_t> io_buf(BOTAN_SYSTEM_RNG_POLL_REQUEST);
96
97 struct ::timeval timeout;
98 timeout.tv_sec = (BOTAN_SYSTEM_RNG_POLL_TIMEOUT_MS / 1000);
99 timeout.tv_usec = (BOTAN_SYSTEM_RNG_POLL_TIMEOUT_MS % 1000) * 1000;
100
101 if(::select(m_max_fd + 1, &read_set, nullptr, nullptr, &timeout) > 0)
102 {
103 for(int dev_fd : m_dev_fds)
104 {
105 if(FD_ISSET(dev_fd, &read_set))
106 {
107 const ssize_t got = ::read(dev_fd, io_buf.data(), io_buf.size());
108
109 if(got > 0)
110 {
111 rng.add_entropy(io_buf.data(), static_cast<size_t>(got));
112 bits += got * 8;
113 }
114 }
115 }
116 }
117 }
118
119 return bits;
120 }

References Botan::RandomNumberGenerator::add_entropy().

The documentation for this class was generated from the following files:

- src/lib/entropy/dev_random/dev_random.h
- src/lib/entropy/dev_random/dev_random.cpp